﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace HighVoltz
{

    public class KeyBindClass
    {
        private System.Windows.Forms.Keys _keyBind;
        // these modifer bools are true if our keybind uses them. otherwise false.
        private bool _shiftkey = false;
        private bool _ctrlkey = false;
        private bool _altkey = false;
        public KeyBindClass()
        {
            _keyBind = new System.Windows.Forms.Keys();
        }

        public KeyBindClass(System.Windows.Forms.Keys k)
        {  // k holds both modifer and  key so we need to extract the modifer
            _shiftkey = (k & Keys.Shift) != 0 ? true : false;
            _ctrlkey = (k & Keys.Control) != 0 ? true : false;
            _altkey = (k & Keys.Alt) != 0 ? true : false;
            // now we remove the modifer flags from k and assign it to _keybind.
            _keyBind = k ^ (Keys.Shift & k) | (Keys.Control & k) | (Keys.Alt & k);
        }

        public System.Windows.Forms.Keys KeyBind
        {
            get { return _keyBind; }
            set
            {   // check for modifer flags 
                _shiftkey = (value & Keys.Shift) != 0 ? true : false;
                _ctrlkey = (value & Keys.Control) != 0 ? true : false;
                _altkey = (value & Keys.Alt) != 0 ? true : false;
                // remove modifer bits
                _keyBind = value ^ (Keys.Shift & value) | (Keys.Control & value) | (Keys.Alt & value);
            }
        }

        public static bool IsKeyDown(System.Windows.Forms.Keys vKey)
        {
            return (Win32.GetAsyncKeyState(vKey) != 0);
        }

        System.Windows.Forms.Keys _lastKey;
        public bool PollKeys()
        {   // checks button status and returns true if our beybind is pressed.
            if (IsKeyDown(_keyBind) && _lastKey != _keyBind && (!(_shiftkey ^ IsKeyDown(Keys.ShiftKey))) &&
    (!(_ctrlkey ^ IsKeyDown(Keys.ControlKey))) && (!(_altkey ^ IsKeyDown(Keys.Menu))))
            {
                _lastKey = _keyBind;
                return true;
            }
            if (!IsKeyDown(_keyBind))
            {
                _lastKey = Keys.None;
            }
            return false;
        }
    }
}
