﻿//!CompilerOption:Optimize:On


using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.World;
using Styx.WoWInternals.WoWObjects;
using System.Collections.Specialized;
using System.Runtime.InteropServices;
using System.Windows.Input;


namespace HighVoltz
{
    class Radar : HBPlugin, IDisposable
    {
        public override string Name { get { return "Radar"; } }
        public override string Author { get { return "Highvoltz"; } }
        public override Version Version { get { return new Version(1, 4); } }
        public override string ButtonText { get { return Name; } }
        public override bool WantButton { get { return true; } }

        public static Radar Instance { get; private set; }
        public RadarSettings MySettings;
        static public Dictionary<ulong, WoWObject> Objects { get; private set; }
        LocalPlayer Me { get { return StyxWoW.Me; } }
        MainForm _gui;
        Thread _keyPollThread;
        Thread _radarThread;
        private static IntPtr _wowHandle = StyxWoW.Memory.Process.MainWindowHandle;
        // contains info about this plugin, used to determine if this plugin is enabled from my thread loop.
        static Styx.Plugins.PluginContainer myPlugin;
        public KeyBindClass RadarKeyBind { get; private set; }
        public bool RadarOn { get; set; }

        public Radar() { Instance = this; }

        bool init = false;
        public override void Initialize()
        {
            if (!init)
            {
                RadarOn = false;
                MySettings = new RadarSettings
                    (Path.Combine(Utilities.AssemblyDirectory, string.Format(@"Settings\{0}\{0}-{1}.xml", Name, Me.Name)));

                RadarKeyBind = new KeyBindClass(MySettings.RadarKeybind);
                Objects = new Dictionary<ulong, WoWObject>();

                _keyPollThread = new Thread(new ThreadStart(WorkerThreadLoop));
                _keyPollThread.IsBackground = true;
                Log("Starting Thread: keyPollThread");
                _keyPollThread.Start();
                init = true;
            }
        }

        public override void OnButtonPress()
        {
            if (_gui == null)
                _gui = new MainForm();
            _gui.ShowDialog();
        }

        public override void Dispose()
        {
            Log("Dispose called");
            _keyPollThread.Abort();
            if (RadarWindow.IsValid)
                RadarWindow.Close2();
        }

        // this is being run in a new thread
        Rect _lastWowRect;
        bool _lastWowFocus = false;
        bool _lastRadarFocus = false;
        public void WorkerThreadLoop()
        {
            while (true)
            {
                try
                {
                    // if keybind is pressed and our wow window is the currently active window then toggle HB
                    if (myPlugin == null)
                        myPlugin = Styx.Plugins.PluginManager.Plugins.FirstOrDefault(p => p.Name.Equals(this.Name));
                    if (myPlugin != null && myPlugin.Enabled)
                    {
                        bool radarWindowFocused = RadarWindow.IsValid ? RadarWindow.IsInForeground() : false;
                        bool wowIsFocused = Win32.GetForegroundWindow() == _wowHandle;
                        if (RadarKeyBind.PollKeys() && (wowIsFocused || radarWindowFocused))
                        {
                            RadarOn = !RadarOn;
                            ToggleRadar();
                        }
                        if (RadarWindow.IsValid)
                        {
                            var windowInfo = Win32.GetWindowInfo(StyxWoW.Memory.Process.MainWindowHandle);

                            // wow has been moved or resized
                            if (_lastWowRect.left != windowInfo.rcClient.left || _lastWowRect.top != windowInfo.rcClient.top ||
                                _lastWowRect.right != windowInfo.rcClient.right || _lastWowRect.bottom != windowInfo.rcClient.bottom)
                            {
                                RadarWindow.Resize(windowInfo.rcClient);
                            }
                            // hide radar if it or wow is not in focus.
                            if (wowIsFocused != _lastWowFocus || radarWindowFocused != _lastRadarFocus)
                            {
                                if (wowIsFocused || radarWindowFocused)
                                    RadarWindow.HideWindow(false);
                                else
                                    RadarWindow.HideWindow(true);
                                _lastWowFocus = wowIsFocused;
                                _lastRadarFocus = radarWindowFocused;
                            }
                            if (RadarWindow.Instance.IsDragged)
                            {
                                if (KeyBindClass.IsKeyDown(Keys.LButton))
                                {
                                    var point = Win32.GetCursorPos();
                                    RadarWindow.DragMove(point.X, point.Y, windowInfo.rcClient);
                                }
                                else
                                {
                                    System.Windows.Point loc = RadarWindow.GetPos(windowInfo.rcClient);
                                    MySettings.RadarX = loc.X;
                                    MySettings.RadarY = loc.Y;
                                    MySettings.Save();
                                    RadarWindow.Instance.IsDragged = false;
                                    Win32.SetForegroundWindow(StyxWoW.Memory.Process.MainWindowHandle);
                                }
                            }
                            if (!TreeRoot.IsRunning && StyxWoW.IsInWorld)
                            {
                                ObjectManager.Update();
                                Instance.UpdateObjectList();
                            }

                            if (StyxWoW.IsInWorld)
                            {
                                RadarWindow.Instance.Dispatcher.BeginInvoke((Action)(RadarWindow.UpdateRadar));
                            }
                            _lastWowRect = windowInfo.rcClient;
                        }
                    }
                    else if (RadarWindow.IsValid)
                        RadarWindow.Close2();
                    Thread.Sleep(50);
                }
                catch (Exception ex)
                {
                    Logging.WriteException(ex);
                }

            }
        }

        void ToggleRadar()
        {
            if (RadarOn)
            {
                _radarThread = new Thread(RadarWindowThreadLoop);
                _radarThread.IsBackground = true;
                _radarThread.SetApartmentState(ApartmentState.STA);
                _radarThread.Start();
            }
            else if (RadarWindow.IsValid)
            {
                RadarWindow.Close2();
            }

            MySettings.Save();
        }

        [STAThread]
        void RadarWindowThreadLoop()
        {
            try
            {
                new RadarWindow().ShowDialog();
            }
            catch (Exception ex)
            {
                Log(ex.ToString());
            }
        }

        public override void Pulse()
        {
            if (StyxWoW.IsInGame && RadarWindow.IsValid)
            {

                UpdateObjectList();

            }

        }



        public static object Locker = new object();
        public void UpdateObjectList()
        {
            lock (Locker)
            {

                uint[] LostObjects = {

                    213741,
                    213364,
                    214439,
                    213972,
                    213967,
                    213970,
                    213969,
                    213742,
                    213768,
                    213966,
                    213964,
                    213653,
                    213749,
                    213842,
                    213968,
                    213971,
                    213765,
                    213962,
                    213363,
                    213960,
                    213649,
                    213651,
                    213751,
                    64272,
                    65552,
                    64004,
                    64191

                };

                Objects =
                ObjectManager.GetObjectsOfType<WoWObject>(true, true).Where(o =>
                    o != null && o.IsValid &&
                        // Players
                    (o.GetType() == typeof(WoWPlayer) && MySettings.TrackPlayers &&
                    (!MySettings.HostilePlayersOnly ||
                    (MySettings.HostilePlayersOnly && ((WoWPlayer)o).MyReaction <= Styx.WoWUnitReaction.Unfriendly))) ||
                        // NPCs 
                    (o.GetType() == typeof(WoWUnit) && MySettings.TrackNPCs &&
                    (!MySettings.HostileNPCsOnly ||
                    (MySettings.HostileNPCsOnly && ((WoWUnit)o).MyReaction <= Styx.WoWUnitReaction.Unfriendly))) ||
                        // Objects
                    (o.GetType() == typeof(WoWGameObject) && MySettings.TrackObjects) ||
                        // Lost Treasures
                    (LostObjects.Contains(o.Entry) && MySettings.TrackLostTreasures) ||
                        // Onyx Eggs
                    (o.Entry == 214945 && MySettings.TrackOnyx) ||
                        // Custom Objects
                    (MySettings.CustomId > 0 && o.Entry == MySettings.CustomId) ||
                    (!string.IsNullOrEmpty(MySettings.CustomName) &&
                    o.Name.ToUpper().Contains(MySettings.CustomName.ToUpper()))
                    ).ToDictionary(u => u.Guid);

                Objects.Add(Me.Guid, Me);
                

            }
        }

        public void Log(string format, params object[] args)
        {
            Logging.Write(Colors.GreenYellow, string.Format("Radar{0}: ", Version) + format, args);
        }
    }
}
