﻿using Styx.Helpers;
namespace HighVoltz
{
    public class RadarSettings : Settings
    {
        public static RadarSettings Instance { get; private set; }
        public RadarSettings(string settingsPath)
            : base(settingsPath)
        {
            Instance = this;
            Load();
        }
        [Setting, DefaultValue(true)]
        public bool TrackPlayers { get; set; }

        [Setting, DefaultValue(false)]
        public bool HostilePlayersOnly { get; set; }

        [Setting, DefaultValue(true)]
        public bool TrackNPCs { get; set; }

        [Setting, DefaultValue(false)]
        public bool HostileNPCsOnly { get; set; }

        [Setting, DefaultValue(true)]
        public bool TrackObjects { get; set; }

        [Setting, DefaultValue(true)]
        public bool TrackLostTreasures { get; set; }

        [Setting, DefaultValue(true)]
        public bool TrackOnyx { get; set; }

        [Setting, DefaultValue(245.00d)]
        public double RadarSize { get; set; }

        [Setting, DefaultValue(640.00d)]
        public double RadarX { get; set; }
        
        [Setting, DefaultValue(512.00d)]
        public double RadarY { get; set; }
        
        [Setting, DefaultValue(0d)]
        public double RadarCenterX { get; set; }

        [Setting, DefaultValue(0d)]
        public double RadarCenterY { get; set; }

        [Setting, DefaultValue("")]
        public string CustomName { get; set; }

        [Setting, DefaultValue(0)]
        public int CustomId { get; set; }

        [Setting, DefaultValue(System.Windows.Forms.Keys.F1)]
        public System.Windows.Forms.Keys RadarKeybind { get; set; }
    }
}
