﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.WoWInternals.WoWObjects;

namespace HighVoltz
{
    public enum WoWObjType { None, LocalPlayer,Player, Npc, Object }
    public class WoWObj
    {
        public WoWObj(WoWObject obj)
        {
            try
            {
                Name = obj.Name;
                Id = obj.Entry;
                Location = obj.Location;
                ObjGuid = obj.Guid;
                Rotation = 360 - obj.RotationDegrees;
                if (obj is WoWUnit)
                    Reaction = ((WoWUnit)obj).MyReaction;
                if (obj.GetType() == typeof(WoWPlayer))
                    Type = WoWObjType.Player;
                else if (obj.GetType() == typeof(WoWUnit))
                    Type = WoWObjType.Npc;
                else if (obj.GetType() == typeof(WoWGameObject))
                    Type = WoWObjType.Object;
                else if (obj.GetType() == typeof(LocalPlayer))
                    Type = WoWObjType.LocalPlayer;
                else
                    Type = WoWObjType.None;
            }
            catch (Exception ex) { Radar.Instance.Log(ex.ToString()); }
        }
        public string Name { get; private set; }
        public WoWPoint Location { get; private set; }
        public Styx.WoWUnitReaction Reaction { get; private set; }
        public WoWObjType Type { get; private set; }
        public ulong ObjGuid { get; private set; }
        public float Rotation { get; private set; }
        public uint Id { get; private set; }
    }

    static class WoWObjExt
    {
        static public Dictionary<ulong, WoWObj> ToDictionary(this IEnumerable<WoWObject> ienum)
        {
            Dictionary<ulong, WoWObj> ret = new System.Collections.Generic.Dictionary<ulong, WoWObj>();
            foreach (var obj in ienum)
            {
                ret.Add(obj.Guid, new WoWObj(obj));
            }
            return ret;
        }
    }
}
